## mingw-w64-gmsh-4.13.1-1.src.tar.zst

=== contrib/Netgen/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2024 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file in the Gmsh root directory for license information.
# Please report all issues on https://gitlab.onelab.info/gmsh/gmsh/issues.

set(gen libsrc/general)
set(lin libsrc/linalg)
set(gpr libsrc/gprim)
set(mes libsrc/meshing)
set(opt libsrc/opti)

set(SRC
  nglib_gmsh.cpp
  ${gen}/array.cpp ${gen}/bitarray.cpp ${gen}/hashtabl.cpp 
    ${gen}/symbolta.cpp ${gen}/table.cpp ${gen}/flags.cpp
    ${gen}/spbita2d.cpp ${gen}/seti.cpp ${gen}/optmem.cpp ${gen}/sort.cpp 
    ${gen}/mystring.cpp ${gen}/parthreads.cpp
    ${gen}/dynamicmem.cpp ${gen}/ngexception.cpp ${gen}/profiler.cpp
  ${lin}/densemat.cpp ${lin}/polynomial.cpp ${lin}/bfgs.cpp
    ${lin}/linopt.cpp ${lin}/linsearch.cpp
  ${gpr}/geom2d.cpp ${gpr}/geom3d.cpp ${gpr}/geomtest3d.cpp ${gpr}/adtree.cpp 
    ${gpr}/transform3d.cpp ${gpr}/geomfuncs.cpp
  ${mes}/meshclass.cpp ${mes}/adfront2.cpp ${mes}/adfront3.cpp 
    ${mes}/geomsearch.cpp ${mes}/global.cpp ${mes}/meshtool.cpp
    ${mes}/netrule2.cpp ${mes}/netrule3.cpp ${mes}/parser2.cpp 
    ${mes}/parser3.cpp ${mes}/ruler2.cpp ${mes}/ruler3.cpp
    ${mes}/meshtype.cpp ${mes}/improve2.cpp ${mes}/smoothing2.5.cpp
    ${mes}/smoothing2.cpp ${mes}/improve3.cpp ${mes}/smoothing3.cpp
    ${mes}/improve2gen.cpp ${mes}/meshing2.cpp ${mes}/meshing3.cpp
    ${mes}/localh.cpp ${mes}/delaunay.cpp ${mes}/topology.cpp 
    ${mes}/clusters.cpp ${mes}/tetrarls.cpp ${mes}/triarls.cpp 
    ${mes}/quadrls.cpp ${mes}/meshfunc.cpp 
    ${mes}/refine.cpp ${mes}/bisect.cpp ${mes}/boundarylayer.cpp 
    ${mes}/specials.cpp ${mes}/msghandler.cpp ${mes}/pyramidrls.cpp
    ${mes}/pyramid2rls.cpp ${mes}/prism2rls.cpp ${mes}/curvedelems.cpp
    ${mes}/validate.cpp ${mes}/basegeom.cpp
)

file(GLOB_RECURSE HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_gmsh_src(contrib/Netgen "${SRC};${HDR}")

=== contrib/metis/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2024 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file in the Gmsh root directory for license information.
# Please report all issues on https://gitlab.onelab.info/gmsh/gmsh/issues.

set(SRC
  GKlib/b64.c
  GKlib/blas.c
  GKlib/csr.c
  GKlib/error.c
  GKlib/evaluate.c
  GKlib/fkvkselect.c
  GKlib/fs.c
  GKlib/getopt.c
  GKlib/gkregex.c
  GKlib/graph.c
  GKlib/htable.c
  GKlib/io.c
  GKlib/itemsets.c
  GKlib/mcore.c
  GKlib/memory.c
  GKlib/omp.c
  GKlib/pdb.c
  GKlib/pqueue.c
  GKlib/random.c
  GKlib/rw.c
  GKlib/seq.c
  GKlib/sort.c
  GKlib/string.c
  GKlib/timers.c
  GKlib/tokenizer.c
  GKlib/util.c
  libmetis/auxapi.c
  libmetis/balance.c 
  libmetis/bucketsort.c
  libmetis/checkgraph.c
  libmetis/coarsen.c
  libmetis/compress.c
  libmetis/contig.c
  libmetis/debug.c
  libmetis/fm.c
  libmetis/fortran.c
  libmetis/frename.c
  libmetis/gklib.c
  libmetis/graph.c
  libmetis/initpart.c
  libmetis/kmetis.c
  libmetis/kwayfm.c
  libmetis/kwayrefine.c
  libmetis/mcutil.c
  libmetis/mesh.c
  libmetis/meshpart.c
  libmetis/minconn.c
  libmetis/mincover.c
  libmetis/mmd.c
  libmetis/ometis.c
  libmetis/options.c
 # libmetis/parmetis.c
  libmetis/pmetis.c
  libmetis/refine.c
  libmetis/separator.c
  libmetis/sfm.c
  libmetis/srefine.c
  libmetis/stat.c
  libmetis/timing.c
  libmetis/util.c
  libmetis/wspace.c
)

file(GLOB_RECURSE HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_gmsh_src(contrib/metis "${SRC};${HDR}")

=== PKGBUILD ===
# Maintainer: ImperatorS79 <fevrier.simon@gmail.com>

_realname=gmsh
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=4.13.1
pkgrel=1
pkgdesc="3D finite element mesh generator with built-in CAD engine and post-processor (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64')
url="https://gmsh.info"
msys2_repository_url="https://gitlab.onelab.info/gmsh/gmsh/"
license=("spdx:GPL-2.0-or-later")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "${MINGW_PACKAGE_PREFIX}-petsc"
             "${MINGW_PACKAGE_PREFIX}-slepc")
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-cairo"
         "${MINGW_PACKAGE_PREFIX}-fltk"
         "${MINGW_PACKAGE_PREFIX}-gmp"
         "${MINGW_PACKAGE_PREFIX}-libjpeg"
         "${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-med"
         "${MINGW_PACKAGE_PREFIX}-opencascade"
         "${MINGW_PACKAGE_PREFIX}-zlib")
source=(https://gmsh.info/src/gmsh-${pkgver}-source.tgz
        0001-fix-link-lib-name.patch
        0002-fix-dynamic-linking.patch)
sha256sums=('77972145f431726026d50596a6a44fb3c1c95c21255218d66955806b86edbe8d'
            'e575ae8fc757694affb6749dc9d52c336691b06159845655ef2ac27aebae8159'
            '4d3f5c4190529e3d45b786adab83f0d65e726357d7367f682ff95b733a88a8c3')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}/gmsh-${pkgver}-source"

  apply_patch_with_msg \
    0001-fix-link-lib-name.patch \
    0002-fix-dynamic-linking.patch
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  CFLAGS+=" -Wno-implicit-function-declaration" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_extra_config[@]}" \
      -DENABLE_BUILD_DYNAMIC=ON \
      -DENABLE_BUILD_SHARED=ON \
      -DENABLE_CAIRO=ON \
      -DENABLE_OCC=ON \
      -DENABLE_OPENMP=ON \
      -DENABLE_OPENACC=ON \
      -DENABLE_PETSC=ON \
      -DENABLE_SLEPC=ON \
      -DGMSH_RELEASE=ON \
      ../gmsh-${pkgver}-source

  "${MINGW_PREFIX}"/bin/cmake --build .
}

check () {
  cd "${srcdir}/build-${MSYSTEM}"
  "${MINGW_PREFIX}"/bin/ctest .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake --install .

  mv "${pkgdir}${MINGW_PREFIX}"/lib/*.dll "${pkgdir}${MINGW_PREFIX}"/bin/
}
